module QA
  feature 'push code to repository', :core do
    context 'with regular account over http' do
      scenario 'user pushes code to the repository'  do
        Page::Main::Entry.act { visit_login_page }
        Page::Main::Login.act { sign_in_using_credentials }

        Scenario::Gitlab::Project::Create.perform do |scenario|
          scenario.name = 'project_with_code'
          scenario.description = 'project with repository'
        end

        Scenario::Gitlab::Repository::Push.perform do |scenario|
          scenario.file_name = 'README.md'
          scenario.file_content = '# This is test project'
          scenario.commit_message = 'Add README.md'
        end

        Page::Project::Show.act do
          wait_for_push
          refresh
        end

        expect(page).to have_content('README.md')
        expect(page).to have_content('This is test project')
      end
    end
  end
end
